diff --git a/client/tests/kvm/kvm_tests.cfg.sample b/client/tests/kvm/kvm_tests.cfg.sample
index 7cd12cb..30d2e9a 100644
--- a/client/tests/kvm/kvm_tests.cfg.sample
+++ b/client/tests/kvm/kvm_tests.cfg.sample
@@ -44,6 +44,14 @@ variants:
         kill_vm_on_error = yes
         keep_screendump_history = yes
 
+    - unattended_install:
+        type = unattended_install
+        kill_vm_on_error = yes
+        force_create_image = yes
+        pre_command = scripts/unattended.py
+        floppy = "floppy.img"
+        extra_params = "-boot d"
+
     - boot:         install setup
         type = boot
         kill_vm_on_error = yes
@@ -150,36 +158,74 @@ variants:
                     - 8.32:
                         no setup
                         image_name = fc8-32
+                        cdrom = linux/Fedora-8-i386-DVD.iso
+                        md5sum = dd6c79fddfff36d409d02242e7b10189
+                        md5sum_1m = dabae451bb69fbbad0e505b25144b1f9
                         install:
                             steps = Fedora-8-i386.steps
-                            cdrom = linux/Fedora-8-i386-DVD.iso
-                            md5sum = dd6c79fddfff36d409d02242e7b10189
-                            md5sum_1m = dabae451bb69fbbad0e505b25144b1f9
 
                     - 8.64:
                         no setup
                         image_name = fc8-64
+                        cdrom = linux/Fedora-8-x86_64-DVD.iso
+                        md5sum = 2cb231a86709dec413425fd2f8bf5295
+                        md5sum_1m = 145f6414e19492649a56c89f0a45e719
                         install:
                             steps = Fedora-8-64.steps
-                            cdrom = linux/Fedora-8-x86_64-DVD.iso
-                            md5sum = 2cb231a86709dec413425fd2f8bf5295
-                            md5sum_1m = 145f6414e19492649a56c89f0a45e719
 
                     - 9.32:
                         image_name = fc9-32
+                        cdrom = linux/Fedora-9-i386-DVD.iso
+                        md5sum = 72601f685ea8c808c303353d8bf4d307
+                        md5sum_1m = f24fa25689e5863f1b99984c6feb787f
                         install:
                             steps = Fedora-9-i386.steps
-                            cdrom = linux/Fedora-9-i386-DVD.iso
-                            md5sum = 72601f685ea8c808c303353d8bf4d307
-                            md5sum_1m = f24fa25689e5863f1b99984c6feb787f
 
                     - 9.64:
                         image_name = fc9-64
+                        cdrom = linux/Fedora-9-x86_64-DVD.iso
+                        md5sum = 05b2ebeed273ec54d6f9ed3d61ea4c96
+                        md5sum_1m = 9822ab5097e37e8fe306ef2192727db4
                         install:
                             steps = Fedora-9-64.steps
-                            cdrom = linux/Fedora-9-x86_64-DVD.iso
-                            md5sum = 05b2ebeed273ec54d6f9ed3d61ea4c96
-                            md5sum_1m = 9822ab5097e37e8fe306ef2192727db4
+
+                    - 10.32:
+                        image_name = fc10-32
+                        cdrom = linux/Fedora-10-i386-DVD.iso
+                        md5sum = 27e581edb392728c4a07d00d3fc5ced0
+                        md5sum_1m = bd67c68bdf595e4ba7131ec702159181
+                        install:
+                            steps =
+                        unattended_install:
+                            tftp = "tftpboot"
+                            extra_params = "-bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/Fedora-10.ks
+
+                    - 11.32:
+                        image_name = fc11-32
+                        cdrom = linux/Fedora-11-i386-DVD.iso
+                        md5sum = e3b1e2d1ba42aa4705fa5f41771b3927
+                        md5sum_1m = dc8ddf90648c247339c721395aa49714
+                        install:
+                            steps =
+                        unattended_install:
+                            tftp = "tftpboot"
+                            extra_params = "-bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/Fedora-11.ks
+
+                    - 11.64:
+                        image_name = fc11-64
+                        cdrom = linux/Fedora-11-x86_64-DVD.iso
+                        md5sum = 9d419844adeb93120215fe7505c9bce8
+                        install:
+                            steps =
+                        unattended_install:
+                            tftp = "tftpboot"
+                            extra_params = "-bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/Fedora-11.ks
 
             - DSL-4.2.5:
                 no setup dbench bonnie linux_s3
@@ -351,11 +397,11 @@ variants:
                 no reboot
                 image_name = win2000-32
                 kill_vm_gracefully = no
+                cdrom = windows/Windows2000_sp4.iso
+                md5sum = dda6039f3a9173f0f6bfae40f5efdfea
+                md5sum_1m = dd28fba196d366d56fe774bd93df5527
                 install:
                     steps = Win2000-32.steps
-                    cdrom = windows/Windows2000_sp4.iso
-                    md5sum = dda6039f3a9173f0f6bfae40f5efdfea
-                    md5sum_1m = dd28fba196d366d56fe774bd93df5527
                     user = user
                     cdkey = WIN_2000_32_CDKEY
                 setup:
@@ -364,25 +410,28 @@ variants:
 
             - WinXP.32:
                 image_name = winXP-32
+                cdrom = windows/WindowsXP-sp2-vlk.iso
+                md5sum = 743450644b1d9fe97b3cf379e22dceb0
+                md5sum_1m = b473bf75af2d1269fec8958cf0202bfd
                 install:
                     steps = WinXP-32.steps
-                    cdrom = windows/WindowsXP-sp2-vlk.iso
-                    md5sum = 743450644b1d9fe97b3cf379e22dceb0
-                    md5sum_1m = b473bf75af2d1269fec8958cf0202bfd
                     user = user
                     cdkey = WIN_XP_32_CDKEY
                 setup:
                     steps = WinXP-32-setupssh.steps
                     cdrom = windows/setupssh.iso
+                unattended_install:
+                    unattended_file = unattended/winxp32.sif
+                    finish_program = deps/finish.exe
 
             - WinXP.64:
                 only install
                 image_name = winXP-64
+                cdrom = windows/WindowsXP-64.iso
+                md5sum = 8d3f007ec9c2060cec8a50ee7d7dc512
+                md5sum_1m = e812363ff427effc512b7801ee70e513
                 install:
                     steps = WinXP-64.steps
-                    cdrom = windows/WindowsXP-64.iso
-                    md5sum = 8d3f007ec9c2060cec8a50ee7d7dc512
-                    md5sum_1m = e812363ff427effc512b7801ee70e513
                     user = user
                     cdkey = WIN_XP_64_CDKEY
 
@@ -394,11 +443,11 @@ variants:
                 variants:
                     - 32:
                         image_name = win2003-32
+                        cdrom = windows/Windows2003_r2_VLK.iso
+                        md5sum = 03e921e9b4214773c21a39f5c3f42ef7
+                        md5sum_1m = 37c2fdec15ac4ec16aa10fdfdb338aa3
                         install:
                             steps = Win2003-32.steps
-                            cdrom = windows/Windows2003_r2_VLK.iso
-                            md5sum = 03e921e9b4214773c21a39f5c3f42ef7
-                            md5sum_1m = 37c2fdec15ac4ec16aa10fdfdb338aa3
                             user = user
                             cdkey = WIN_2003_32_CDKEY
                         setup:
@@ -408,11 +457,11 @@ variants:
                     - 64:
                         only install
                         image_name = win2003-64
+                        cdrom = windows/Windows2003-x64.iso
+                        md5sum = 5703f87c9fd77d28c05ffadd3354dbbd
+                        md5sum_1m = 439393c384116aa09e08a0ad047dcea8
                         install:
                             steps = Win2003-64.steps
-                            cdrom = windows/Windows2003-x64.iso
-                            md5sum = 5703f87c9fd77d28c05ffadd3354dbbd
-                            md5sum_1m = 439393c384116aa09e08a0ad047dcea8
                             user = user
                             cdkey = WIN_2003_64_CDKEY
 
@@ -616,7 +665,28 @@ variants:
     - @custom:
         only qcow2.*ide.*default.*up.*Ubuntu-8.10-server.*(autotest.sleeptest)
         only rtl8139
+    - @winXP_32_unattended:
+        only qcow2
+        only ide
+        only default
+        only up
+        only WinXP.32
+        no install setup
+        no kvm_hugepages
+        only unattended_install
+        only rtl8139
+    - @fc11_kickstart:
+        only qcow2
+        only ide
+        only default
+        only up
+        only Fedora.11.64
+        no install setup
+        no kvm_hugepages
+        only unattended_install boot shutdown
+        only rtl8139
 
 
 # Choose your test list
-only fc8_quick
+#only fc11_kickstart
+only winXP_32_unattended