diff --git a/client/tests/kvm/kvm_tests.cfg.sample b/client/tests/kvm/kvm_tests.cfg.sample
index 201b0e1..285a38f 100644
--- a/client/tests/kvm/kvm_tests.cfg.sample
+++ b/client/tests/kvm/kvm_tests.cfg.sample
@@ -119,7 +119,6 @@ variants:
 
     - autoit:       install setup
         type = autoit
-        cdrom = windows/autoit.iso
         autoit_binary = D:\AutoIt3.exe
         autoit_script_timeout = 600
         autoit_script_params =
@@ -362,17 +361,19 @@ variants:
         # file_transfer_client = scp
         # file_transfer_port = 22
 
+        # This ISO will be used for all tests except install:
+        cdrom = windows/winutils.iso
+
         migrate:
             migration_test_command = ver && vol
         stress_boot:
             alive_test_cmd = systeminfo
         timedrift:
-            # For this to work, the ISO should contain vlc (vlc.exe) and a video (ED_1024.avi)
-            cdrom = windows/vlc.iso
             time_command = "echo TIME: %date% %time%"
             time_filter_re = "(?<=TIME: \w\w\w ).{19}(?=\.\d\d)"
             time_format = "%m/%d/%Y %H:%M:%S"
-            guest_load_command = 'cmd /c "d:\vlc -f --loop --no-qt-privacy-ask --no-qt-system-tray d:\ED_1024.avi"'
+            # For this to work, the cdrom at d: should contain vlc (d:\vlc\vlc.exe) and a video (d:\ED_1024.avi)
+            guest_load_command = 'cmd /c "d:\vlc\vlc -f --loop --no-qt-privacy-ask --no-qt-system-tray d:\ED_1024.avi"'
             # Alternative guest load:
             #guest_load_command = "(dir /s && dir /s && dir /s && dir /s) > nul"
             guest_load_stop_command = "taskkill /F /IM vlc.exe"
@@ -395,7 +396,6 @@ variants:
                     user = user
                 setup:
                     steps = Win2000-32-rss.steps
-                    cdrom = windows/rss.iso
 
             - WinXP.32:
                 image_name = winXP-32
@@ -407,7 +407,6 @@ variants:
                     user = user
                 setup:
                     steps = WinXP-32-rss.steps
-                    cdrom = windows/rss.iso
 
             - WinXP.64:
                 no reboot
@@ -420,7 +419,6 @@ variants:
                     user = user
                 setup:
                     steps = WinXP-64-rss.steps
-                    cdrom = windows/rss.iso
 
             - Win2003:
                 image_size = 20G
@@ -438,7 +436,6 @@ variants:
                             user = user
                         setup:
                             steps = Win2003-32-rss.steps
-                            cdrom = windows/rss.iso
 
                     - 64:
                         image_name = win2003-64
@@ -450,7 +447,6 @@ variants:
                             user = user
                         setup:
                             steps = Win2003-64-rss.steps
-                            cdrom = windows/rss.iso
 
             - WinVista:
                 image_name = winvista
@@ -466,7 +462,6 @@ variants:
                             md5sum_1m = c724e9695da483bc0fd59e426eaefc72
                         setup:
                             steps = WinVista-32-rss.steps
-                            cdrom = windows/rss.iso
 
                     - 64:
                         image_name += -64
@@ -477,7 +472,6 @@ variants:
                             md5sum_1m = 0947bcd5390546139e25f25217d6f165
                         setup:
                             steps = WinVista-64-rss.steps
-                            cdrom = windows/rss.iso
 
             - Win2008:
                 image_name = win2008
@@ -497,7 +491,6 @@ variants:
                             md5sum_1m=07d7f5006393f74dc76e6e2e943e2440
                         setup:
                             steps = Win2008-32-rss.steps
-                            cdrom = windows/rss.iso
 
                     - 64:
                         image_name += -64
@@ -511,7 +504,6 @@ variants:
                             passwd = 1q2w3eP
                         setup:
                             steps = Win2008-64-rss.steps
-                            cdrom = windows/rss.iso
 
     # Unix/BSD section
     - @Unix: