diff --git a/client/tests/kvm/kvm_tests.cfg.sample b/client/tests/kvm/kvm_tests.cfg.sample
index 9d79240..411a63f 100644
--- a/client/tests/kvm/kvm_tests.cfg.sample
+++ b/client/tests/kvm/kvm_tests.cfg.sample
@@ -636,6 +636,26 @@ variants:
                         setup:
                             steps = Win2008-64-rss.steps
 
+            - Win7:
+                image_name = win7
+                image_size = 20G
+                shutdown_command = shutdown /s /f /t 0
+                reboot_command = shutdown /r /f /t 0
+
+                variants:
+                    - 64:
+                        image_name += -64
+                        install:
+                            cdrom = windows/en_windows_7_ultimate_x64_dvd_x15-65922.iso
+                            md5sum=f43d22e4fb07bf617d573acd8785c028
+                            md5sum_1m=b44d8cf99dbed2a5cb02765db8dfd48f
+                            type = steps
+                            steps = Win7-64.steps
+                            passwd = 1q2w3eP
+                        setup:
+                            type = steps
+                            steps = Win7-64-rss.steps
+
     # Unix/BSD section
     - @Unix:
         only install
diff --git a/client/tests/kvm/steps/Win7-64-rss.steps b/client/tests/kvm/steps/Win7-64-rss.steps
new file mode 100644
index 0000000..60cdf3f
--- /dev/null
+++ b/client/tests/kvm/steps/Win7-64-rss.steps
@@ -0,0 +1,121 @@
+# Generated by Step Maker
+# Generated on Fri Oct  9 12:19:22 2009
+# uname -a: Linux freedom 2.6.30.8-64.fc11.x86_64 #1 SMP Fri Sep 25 04:43:32 EDT 2009 x86_64 x86_64 x86_64 GNU/Linux
+# --------------------------------
+step 68.16
+screendump 20091009_122030_126edf17af893d63770a35b065ad9684.ppm
+# Full desktop reached
+barrier_2 204 20 394 569 5806a5dcc7f62a613257615904c52379 341
+# Sending keys: ctrl-esc
+key ctrl-esc
+# --------------------------------
+step 71.95
+screendump 20091009_122059_8d427a5f279dc8ae959e7de8ecb714d3.ppm
+# Open explorer on CDROM
+barrier_2 167 24 346 566 0ef2b2c38edceb443e25bc046a7484ff 18
+# Sending keys: d shift-0x27 0x2b ret
+key d
+key shift-0x27
+key 0x2b
+key ret
+# --------------------------------
+step 78.35
+screendump 20091009_122153_31bf8cb7ef6dc512627e7fcb904cd9e3.ppm
+barrier_2 189 21 374 570 cdbd57fb3e8b40d75c8efe8306ad8c67 27
+# Sending keys: ret
+key ret
+# --------------------------------
+step 85.00
+screendump 20091009_122208_7cccc3cbc6d27b0c9efa4a4d0f63008f.ppm
+# Choose setuprss on file manager
+barrier_2 157 20 396 569 1361ffa0712e61215804b2e2e5a5c7c4 32
+# Sending keys: down down down down down down down
+key down
+key down
+key down
+key down
+key down
+key down
+key down
+# --------------------------------
+step 89.28
+screendump 20091009_122238_9ff5d6fe3a35b0a7cd0fe6adf4fde72e.ppm
+# Open right mouse click menu
+barrier_2 119 19 411 572 4e9ca5a404d1ab5df09a45f4a9733b3c 14
+# Sending keys: shift-f10
+key shift-f10
+# --------------------------------
+step 99.69
+screendump 20091009_122308_be27990919459a1ed090c74366f01828.ppm
+# Choose run as administrator
+barrier_2 132 19 374 568 b434b688de3177c65aafb8e1d589efdb 51
+# Sending keys: down down down down
+key down
+key down
+key down
+key down
+# --------------------------------
+step 103.73
+screendump 20091009_122331_46789aa2a09e35b81bf2c3501b3cecd5.ppm
+# Go for it
+barrier_2 146 25 351 566 8c7cf5bbbfc13bfc33ed4f1adf9f5de8 15
+# Sending keys: ret
+key ret
+# --------------------------------
+step 116.13
+screendump 20091009_122353_46ef6f6206c77f5769135843d83d1072.ppm
+barrier_2 146 23 343 569 77cde7c97517921a4552e50f56c7d3f0 61
+# Sending keys: tab tab
+key tab
+key tab
+# --------------------------------
+step 118.68
+screendump 20091009_122403_00c5eea0156c28529cfc0d6eaf04bad5.ppm
+barrier_2 185 23 332 570 eed8e4f0defad1bbad5304e13d028176 10
+# Sending keys: tab
+key tab
+# --------------------------------
+step 121.04
+screendump 20091009_122413_8f255650dc2c7a02b4300c4afb26aa72.ppm
+barrier_2 182 21 325 569 071cdab9fb85e618a960bcfd715377cd 11
+# Sending keys: ret
+key ret
+# --------------------------------
+step 139.18
+screendump 20091009_122446_a66159376c4ce1a58ccc9649867709eb.ppm
+barrier_2 114 21 395 570 b4361d16d8ff7de8b9e751f816a92fe5 90
+# Sending keys: alt+f4
+key alt+f4
+# --------------------------------
+step 143.81
+screendump 20091009_122446_a66159376c4ce1a58ccc9649867709eb.ppm
+# call exec
+barrier_2 121 27 433 566 f5f1b81e0c5eb28a6ff6446873b43138 22
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 149.24
+screendump 20091009_122620_750644b17fcca13bc20fceb876821ebf.ppm
+sleep 5
+barrier_2 86 20 469 569 ed4e8e74a2c641b7778fc482790848d2 26
+# Sending keys: s h u t d o w n spc slash s spc slash f spc slash t spc 0 ret
+key s
+key h
+key u
+key t
+key d
+key o
+key w
+key n
+key spc
+key slash
+key s
+key spc
+key slash
+key f
+key spc
+key slash
+key t
+key spc
+key 0
+key ret
diff --git a/client/tests/kvm/steps/Win7-64.steps b/client/tests/kvm/steps/Win7-64.steps
new file mode 100644
index 0000000..ee9d2b5
--- /dev/null
+++ b/client/tests/kvm/steps/Win7-64.steps
@@ -0,0 +1,187 @@
+# Generated by Step Maker
+# Generated on Thu Oct  8 11:26:50 2009
+# uname -a: Linux freedom 2.6.30.8-64.fc11.x86_64 #1 SMP Fri Sep 25 04:43:32 EDT 2009 x86_64 x86_64 x86_64 GNU/Linux
+# --------------------------------
+step 28.78
+screendump 20091006_141238_3057dcf031c3dfd2468a12fd7b6090f4.ppm
+# Initial screen
+barrier_2 223 131 291 138 c497b54e51a5742cb1121c2fce59ee75 144
+# Sending keys: tab tab tab ret
+key tab
+key tab
+key tab
+key ret
+# --------------------------------
+step 32.13
+screendump 20091006_142123_f8b055c0e526d77e81347352b34f2cc2.ppm
+# Install now
+barrier_2 213 127 296 137 0368e2f071d6b27ffa58b2cfce555d50 12
+# Sending keys: ret
+key ret
+# --------------------------------
+step 52.67
+screendump 20091006_142209_1e8e0575e08325cde87465fc7c7244ca.ppm
+# License agreement
+barrier_2 258 32 104 81 a503fa556aaebdccf5b5c985bcb9d3cb 102
+# Sending keys: spc tab ret
+key spc
+key tab
+key ret
+# --------------------------------
+step 55.79
+screendump 20091006_144429_32f79dedc8fb483261e97f9f9e37e1a1.ppm
+# Custom install
+barrier_2 296 41 119 75 b6b03a123ecf0850d36ee6392eabfe2d 12
+# Sending keys: tab ret
+key tab
+key ret
+# --------------------------------
+step 61.04
+screendump 20091006_144459_fc54578a99d23b88333d0eace1f18205.ppm
+# Disk setup
+barrier_2 325 43 111 77 9e289cd7c1194efa40efdb43680e6540 24
+# Sending keys: alt-n
+key alt-n
+# --------------------------------
+step 1493.86
+screendump 20091006_151248_fe2afaa324427608c3ac56163ebf7e9b.ppm
+# Username
+barrier_2 245 61 219 173 96efd46410b8cdd75fc63b50767240bf 7163
+# Sending keys: u s e r tab tab ret
+key u
+key s
+key e
+key r
+key tab
+key tab
+key ret
+# --------------------------------
+step 1498.71
+screendump 20091008_115352_71e62396870216bbd96bf157ca9b32a1.ppm
+# Password screen
+barrier_2 240 33 136 125 9ac832bef2bd1c48783a9ab53033394c 16
+# Sending keys: var passwd tab var passwd tab h i n t tab ret
+key var
+key passwd
+key tab
+key var
+key passwd
+key tab
+key h
+key i
+key n
+key t
+key tab
+key ret
+# --------------------------------
+step 1505.31
+screendump 20091008_115655_e603625ba5cfeb45e647f6efa1de5195.ppm
+# CD key
+barrier_2 259 34 129 125 e4e0e77830739bf8a556cea8cfdb346d 20
+# Sending keys: var cdkey tab tab ret
+key var
+key cdkey
+key tab
+key tab
+key ret
+# --------------------------------
+step 1511.18
+screendump 20091008_115853_4fdbc3ffe3293743239a81796ba8a0b6.ppm
+barrier_2 266 35 124 124 fa13542c12a3f3ba2b0c660dcf5dc4ac 24
+# Sending keys: alt+f4
+key alt+f4
+# --------------------------------
+step 1518.62
+screendump 20091008_115853_4fdbc3ffe3293743239a81796ba8a0b6.ppm
+barrier_2 266 32 127 124 15573a6a5679ab805265b06f92141f5a 36
+# Sending keys: esc
+key esc
+# --------------------------------
+step 1523.08
+screendump 20091008_120111_cc2e0cd9a72793e3fcddb7f494a246d0.ppm
+barrier_2 247 42 130 117 af29dd300f881f28f5e3706aca4fdb1e 21
+# Sending keys: tab tab ret
+key tab
+key tab
+key ret
+# --------------------------------
+step 1529.22
+screendump 20091008_120152_f8342b8812dba0e195834ec892048165.ppm
+barrier_2 479 33 132 124 71a7784af46b0aa7e414a887696c7469 27
+# Sending keys: ret
+key ret
+# --------------------------------
+step 1537.58
+screendump 20091008_120213_3ffb0119b344026baba11e195aa7f20a.ppm
+# Time zone
+barrier_2 276 37 132 121 348adc44bb7b646bd43ca88c961fd99d 41
+# Sending keys: alt-n
+key alt-n
+# --------------------------------
+step 1549.54
+screendump 20091008_120240_b9b68e66a5f357a96cede06d75eecf92.ppm
+# Choose nw
+barrier_2 301 33 133 127 7d93ea8ec144c1d1e9d5cd550cb0fb47 59
+# Sending keys: tab ret
+key tab
+key ret
+# --------------------------------
+step 1556.86
+screendump 20091008_120307_19b608d6f6fe76c5102383a431073710.ppm
+barrier_2 278 47 128 118 0ccbdfe0db0ce66c7e08e8a4a0c17189 34
+# Sending keys: alt-n
+key alt-n
+# --------------------------------
+step 1569.68
+screendump 20091008_120405_be6c767f63280ffe9a849762f99cc607.ppm
+barrier_2 295 34 130 122 4168f786d2df6907eba53de14b8ef04d 63
+# Sending keys: tab alt-n
+key tab
+key alt-n
+# --------------------------------
+step 1574.37
+screendump 20091008_120423_8ff37adb0aae6fe37fd45bb49f382421.ppm
+barrier_2 326 43 124 119 966661e5d43098bc8232004265255d40 21
+# Sending keys: tab alt-n
+key tab
+key alt-n
+# --------------------------------
+step 1577.79
+screendump 20091008_120446_c79e259c6edb991f032263bca9c1c289.ppm
+barrier_2 308 32 122 122 a64bda6d86d4ba8f219cc4751bc6da01 15
+# Sending keys: tab ret
+key tab
+key ret
+# --------------------------------
+step 1664.72
+screendump 20091008_120640_077bf3e02c8b9fd723558e0ba32fb88f.ppm
+# Desktop reached
+barrier_2 166 22 391 568 35580e686a5485450714ebcdb7178b7e 432
+# Sending keys: 0xdc-r
+key 0xdc-r
+# --------------------------------
+step 1671.01
+screendump 20091008_121857_af7ead153110c1220828490b5e89b33d.ppm
+sleep 10
+barrier_2 134 19 457 571 040eb9fb0b71cf5e21b692e0c5d506e1 30
+# Sending keys: s h u t d o w n spc slash s spc slash f spc slash t spc 0 ret
+key s
+key h
+key u
+key t
+key d
+key o
+key w
+key n
+key spc
+key slash
+key s
+key spc
+key slash
+key f
+key spc
+key slash
+key t
+key spc
+key 0
+key ret