diff --git a/client/tests/kvm/kvm_tests.cfg.sample b/client/tests/kvm/kvm_tests.cfg.sample
index 573206c..8be0565 100644
--- a/client/tests/kvm/kvm_tests.cfg.sample
+++ b/client/tests/kvm/kvm_tests.cfg.sample
@@ -432,7 +432,14 @@ variants:
                             cdrom=linux/RHEL-5.3-i386-DVD.iso
                             md5sum=371c62851611fd32ead440df6f24a296
                             md5sum_1m=242318dd44152210f6ff6cdda1bfbf51
-
+                        unattended_install:
+                            cdrom=linux/RHEL-5.3-i386-DVD.iso
+                            md5sum=371c62851611fd32ead440df6f24a296
+                            md5sum_1m=242318dd44152210f6ff6cdda1bfbf51
+                            tftp = "images/tftpboot"
+                            extra_params += " -bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/RHEL-5-series.ks
                     - 5.3.x86_64:
                         no setup
                         image_name = rhel5-64
@@ -441,7 +448,14 @@ variants:
                             cdrom=linux/RHEL-5.3-x86_64-DVD.iso
                             md5sum=c5ed6b284410f4d8212cafc78fd7a8c5
                             md5sum_1m=b999f437583098ea5bbd56fb1de1d011
-
+                        unattended_install:
+                            cdrom=linux/RHEL-5.3-x86_64-DVD.iso
+                            md5sum=c5ed6b284410f4d8212cafc78fd7a8c5
+                            md5sum_1m=b999f437583098ea5bbd56fb1de1d011
+                            tftp = "images/tftpboot"
+                            extra_params += " -bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/RHEL-5-series.ks
                     - 4.7.i386:
                         no setup autotest
                         image_name = rhel4-32
@@ -450,7 +464,14 @@ variants:
                             cdrom=linux/RHEL-4.7-i386-DVD.iso
                             md5sum=ee5092653732a88ddbaf8eef2484c500
                             md5sum_1m=127081cbed825d7232331a2083975528
-
+                        unattended_install:
+                            cdrom=linux/RHEL-4.7-i386-DVD.iso
+                            md5sum=ee5092653732a88ddbaf8eef2484c500
+                            md5sum_1m=127081cbed825d7232331a2083975528
+                            tftp = "images/tftpboot"
+                            extra_params += " -bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/RHEL-4-series.ks
                     - 4.7.x86_64:
                         no setup autotest
                         image_name = rhel4-64
@@ -459,7 +480,14 @@ variants:
                             cdrom=linux/RHEL-4.7-x86_64-DVD.iso
                             md5sum=ea9dae16dd86f7d94092d0e672333292
                             md5sum_1m=58fa63eaee68e269f4cb1d2edf479792
-
+                        unattended_install:
+                            cdrom=linux/RHEL-4.7-x86_64-DVD.iso
+                            md5sum=ea9dae16dd86f7d94092d0e672333292
+                            md5sum_1m=58fa63eaee68e269f4cb1d2edf479792
+                            tftp = "images/tftpboot"
+                            extra_params += " -bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/RHEL-4-series.ks
                     - 3.9.i386:
                         no setup autotest linux_s3
                         image_name = rhel3-32
@@ -468,7 +496,14 @@ variants:
                             cdrom=linux/RHEL-3.9-i386-DVD.iso
                             md5sum=ddd11a1cb104119039b0fa05df6d52b8
                             md5sum_1m=5f10c9417c7b8372b3456c1b5f3f9ed0
-
+                        unattended_install:
+                            cdrom=linux/RHEL-3.9-i386-DVD.iso
+                            md5sum=ddd11a1cb104119039b0fa05df6d52b8
+                            md5sum_1m=5f10c9417c7b8372b3456c1b5f3f9ed0
+                            tftp = "images/tftpboot"
+                            extra_params += " -bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/RHEL-3-series.ks
                     - 3.9.x86_64:
                         no setup autotest linux_s3
                         image_name = rhel3-64
@@ -477,7 +512,14 @@ variants:
                             cdrom=linux/RHEL-3.9-x86_64-DVD.iso
                             md5sum=bf4635e4a4bd3b43838e72bc8c329d55
                             md5sum_1m=18ecd37b639109f1b2af05cfb57dfeaf
-
+                        unattended_install:
+                            cdrom=linux/RHEL-3.9-x86_64-DVD.iso
+                            md5sum=bf4635e4a4bd3b43838e72bc8c329d55
+                            md5sum_1m=18ecd37b639109f1b2af05cfb57dfeaf
+                            tftp = "images/tftpboot"
+                            extra_params += " -bootp /pxelinux.0 -boot n"
+                            kernel_args = "ks=floppy nicdelay=60"
+                            unattended_file = unattended/RHEL-3-series.ks
     # Windows section
     - @Windows:
         no autotest linux_s3
diff --git a/client/tests/kvm/unattended/RHEL-3-series.ks b/client/tests/kvm/unattended/RHEL-3-series.ks
new file mode 100644
index 0000000..2364b74
--- /dev/null
+++ b/client/tests/kvm/unattended/RHEL-3-series.ks
@@ -0,0 +1,39 @@
+install
+cdrom
+text
+reboot
+lang en_US.UTF-8
+langsupport --default=en_US.UTF-8 en_US.UTF-9
+keyboard us
+network --bootproto dhcp
+rootpw 123456
+firewall --enabled --ssh
+timezone America/New_York
+firstboot --disable
+bootloader --location=mbr
+clearpart --all --initlabel 
+autopart
+reboot
+mouse generic3ps/2
+skipx
+
+%packages --resolvedeps
+@ admin-tools
+@ core
+@ base
+@ base-x
+@ gnome-desktop
+@ development-libs
+@ development-tools
+
+%post --interpreter /usr/bin/python
+import socket, os
+os.system('chkconfig sshd on')
+os.system('iptables -F')
+port = 12323
+buf = 1024
+addr = ('10.0.2.2', port)
+client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
+client.connect(addr)
+client.sendto('done', addr)
+client.close()
diff --git a/client/tests/kvm/unattended/RHEL-4-series.ks b/client/tests/kvm/unattended/RHEL-4-series.ks
new file mode 100644
index 0000000..88dd2fd
--- /dev/null
+++ b/client/tests/kvm/unattended/RHEL-4-series.ks
@@ -0,0 +1,40 @@
+install
+cdrom
+text
+reboot
+lang en_US.UTF-8
+langsupport --default=en_US.UTF-8 en_US.UTF-9
+keyboard us
+network --bootproto dhcp
+rootpw 123456
+firewall --enabled --ssh
+selinux --enforcing
+timezone --utc America/New_York
+firstboot --disable
+bootloader --location=mbr
+zerombr
+clearpart --all --initlabel
+autopart
+reboot
+
+%packages
+@ admin-tools
+@ core
+@ base
+@ base-x
+@ gnome-desktop
+@ development-libs
+@ development-tools
+
+%post --interpreter /usr/bin/python
+import socket, os
+os.system('chkconfig sshd on')
+os.system('iptables -F')
+os.system('echo 0 > /selinux/enforce')
+port = 12323
+buf = 1024
+addr = ('10.0.2.2', port)
+client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
+client.connect(addr)
+client.sendto('done', addr)
+client.close()
diff --git a/client/tests/kvm/unattended/RHEL-5-series.ks b/client/tests/kvm/unattended/RHEL-5-series.ks
new file mode 100644
index 0000000..3c9371f
--- /dev/null
+++ b/client/tests/kvm/unattended/RHEL-5-series.ks
@@ -0,0 +1,39 @@
+install
+cdrom
+text
+reboot
+lang en_US.UTF-8
+keyboard us
+key --skip
+network --bootproto dhcp
+rootpw 123456
+firewall --enabled --ssh
+selinux --enforcing
+timezone --utc America/New_York
+firstboot --disable
+bootloader --location=mbr
+zerombr
+clearpart --all --initlabel
+autopart
+reboot
+
+%packages
+@admin-tools
+@base
+@base-x
+@gnome-desktop
+@development-libs
+@development-tools
+
+%post --interpreter /usr/bin/python
+import socket, os
+os.system('chkconfig sshd on')
+os.system('iptables -F')
+os.system('echo 0 > /selinux/enforce')
+port = 12323
+buf = 1024
+addr = ('10.0.2.2', port)
+client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
+client.connect(addr)
+client.sendto('done', addr)
+client.close()